GDCM 2.2.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
gdcm::JPEGCodec Class Reference

JPEG codec Class to do JPEG (8bits, 12bits, 16bits lossy & lossless). It redispatch in between the different codec implementation: gdcm::JPEG8Codec, gdcm::JPEG12Codec & gdcm::JPEG16Codec It also support inconsistency in between DICOM header and JPEG compressed stream ImageCodec implementation for the JPEG case. More...

`#include <gdcmJPEGCodec.h>`

Inheritance diagram for gdcm::JPEGCodec:
[legend]
Collaboration diagram for gdcm::JPEGCodec:
[legend]

## Public Member Functions

| JPEGCodec ()
| ~JPEGCodec ()
bool | CanCode (TransferSyntax const &ts) const
| Return whether this coder support this transfer syntax (can code it)
bool | CanDecode (TransferSyntax const &ts) const
| Return whether this decoder support this transfer syntax (can decode it)
bool | Code (DataElement const &in, DataElement &out)
| Compress into JPEG.
void | ComputeOffsetTable (bool b)
| Compute the offset table:
bool | Decode (DataElement const &is, DataElement &os)
| Decode.
virtual bool | GetHeaderInfo (std::istream &is, TransferSyntax &ts)
bool | GetLossless () const
double | GetQuality () const
void | SetLossless (bool l)
void | SetPixelFormat (PixelFormat const &pf)
void | SetQuality (double q)
Public Member Functions inherited from gdcm::ImageCodec
| ImageCodec ()
| ~ImageCodec ()
const unsigned int * | GetDimensions () const
bool | GetLossyFlag () const
const LookupTable & | GetLUT () const
bool | GetNeedByteSwap () const
unsigned int | GetNumberOfDimensions () const
const PhotometricInterpretation & | GetPhotometricInterpretation () const
PixelFormat & | GetPixelFormat ()
const PixelFormat & | GetPixelFormat () const
unsigned int | GetPlanarConfiguration () const
bool | IsLossy () const
void | SetDimensions (const unsigned int d[3])
void | SetDimensions (const std::vector< unsigned int > &d)
void | SetLossyFlag (bool l)
void | SetLUT (LookupTable const &lut)
void | SetNeedByteSwap (bool b)
void | SetNeedOverlayCleanup (bool b)
void | SetNumberOfDimensions (unsigned int dim)
void | SetPhotometricInterpretation (PhotometricInterpretation const &pi)
void | SetPlanarConfiguration (unsigned int pc)

## Protected Member Functions

bool | DecodeByStreams (std::istream &is, std::ostream &os)
bool | DecodeExtent (char *buffer, unsigned int xmin, unsigned int xmax, unsigned int ymin, unsigned int ymax, unsigned int zmin, unsigned int zmax, std::istream &is)
bool | IsValid (PhotometricInterpretation const &pi)
void | SetBitSample (int bit)
Protected Member Functions inherited from gdcm::ImageCodec
bool | DoByteSwap (std::istream &is_, std::ostream &os)
bool | DoInvertMonochrome (std::istream &is_, std::ostream &os)
bool | DoOverlayCleanup (std::istream &is_, std::ostream &os)
bool | DoPaddedCompositePixelCode (std::istream &is_, std::ostream &os)
bool | DoPlanarConfiguration (std::istream &is_, std::ostream &os)
bool | DoSimpleCopy (std::istream &is_, std::ostream &os)
bool | DoYBR (std::istream &is_, std::ostream &os)

## Protected Attributes

int | BitSample
bool | Lossless
int | Quality
Protected Attributes inherited from gdcm::ImageCodec
unsigned int | Dimensions [3]
bool | LossyFlag
LUTPtr | LUT
bool | NeedByteSwap
bool | NeedOverlayCleanup
unsigned int | NumberOfDimensions
PixelFormat | PF
PhotometricInterpretation | PI
unsigned int | PlanarConfiguration
bool | RequestPaddedCompositePixelCode
bool | RequestPlanarConfiguration

## Friends

class | ImageRegionReader

## Additional Inherited Members

Protected Types inherited from gdcm::ImageCodec
typedef SmartPointer< LookupTable > | LUTPtr

## Detailed Description

JPEG codec Class to do JPEG (8bits, 12bits, 16bits lossy & lossless). It redispatch in between the different codec implementation: gdcm::JPEG8Codec, gdcm::JPEG12Codec & gdcm::JPEG16Codec It also support inconsistency in between DICOM header and JPEG compressed stream ImageCodec implementation for the JPEG case.

Note
  Things you should know if you ever want to dive into DICOM/JPEG world (among other):

- http://groups.google.com/group/comp.protocols.dicom/browse_thread/thread/625e46919f2080e1
- http://groups.google.com/group/comp.protocols.dicom/browse_thread/thread/75fdfccc65a6243
- http://groups.google.com/group/comp.protocols.dicom/browse_thread/thread/2d525ef6a2f093ed
- http://groups.google.com/group/comp.protocols.dicom/browse_thread/thread/6b93af410f8c921f

Examples:
  GetJPEGSamplePrecision.cxx.

## Constructor & Destructor Documentation

gdcm::JPEGCodec::JPEGCodec | ( |  | ) |

gdcm::JPEGCodec::~JPEGCodec | ( |  | ) |

## Member Function Documentation

bool gdcm::JPEGCodec::CanCode | ( | TransferSyntax const & |  | ) | const

virtual

Return whether this coder support this transfer syntax (can code it)

Reimplemented from gdcm::ImageCodec.

bool gdcm::JPEGCodec::CanDecode | ( | TransferSyntax const & |  | ) | const

virtual

Return whether this decoder support this transfer syntax (can decode it)

Reimplemented from gdcm::ImageCodec.

bool gdcm::JPEGCodec::Code | ( | DataElement const & | in,
|  | DataElement & | out
| ) |  |

virtual

Compress into JPEG.

Reimplemented from gdcm::Coder.

void gdcm::JPEGCodec::ComputeOffsetTable | ( | bool | b | ) |

Compute the offset table:

bool gdcm::JPEGCodec::Decode | ( | DataElement const & | ,
|  | DataElement & |
| ) |  |

virtual

Decode.

Reimplemented from gdcm::ImageCodec.

bool gdcm::JPEGCodec::DecodeByStreams | ( | std::istream & | is,
|  | std::ostream & | os
| ) |  |

protectedvirtual

Reimplemented from gdcm::ImageCodec.

bool gdcm::JPEGCodec::DecodeExtent | ( | char * | buffer,
|  | unsigned int | xmin,
|  | unsigned int | xmax,
|  | unsigned int | ymin,
|  | unsigned int | ymax,
|  | unsigned int | zmin,
|  | unsigned int | zmax,
|  | std::istream & | is
| ) |  |

protected

virtual bool gdcm::JPEGCodec::GetHeaderInfo | ( | std::istream & | is,
|  | TransferSyntax & | ts
| ) |  |

virtual

Reimplemented from gdcm::ImageCodec.

Reimplemented in gdcm::JPEG12Codec, gdcm::JPEG16Codec, and gdcm::JPEG8Codec.

Examples:
  GetJPEGSamplePrecision.cxx.

bool gdcm::JPEGCodec::GetLossless | ( |  | ) | const

double gdcm::JPEGCodec::GetQuality | ( |  | ) | const

bool gdcm::JPEGCodec::IsValid | ( | PhotometricInterpretation const & | pi | ) |

protectedvirtual

Reimplemented from gdcm::ImageCodec.

void gdcm::JPEGCodec::SetBitSample | ( | int | bit | ) |

protected

void gdcm::JPEGCodec::SetLossless | ( | bool | l | ) |

void gdcm::JPEGCodec::SetPixelFormat | ( | PixelFormat const & | pf | ) |

virtual

Reimplemented from gdcm::ImageCodec.

Examples:
  GetJPEGSamplePrecision.cxx.

void gdcm::JPEGCodec::SetQuality | ( | double | q | ) |

## Friends And Related Function Documentation

friend class ImageRegionReader

friend

## Member Data Documentation

int gdcm::JPEGCodec::BitSample

protected

bool gdcm::JPEGCodec::Lossless

protected

int gdcm::JPEGCodec::Quality

protected

The documentation for this class was generated from the following file:

- gdcmJPEGCodec.h